<?php

namespace Drupal\vipps_mobilepay_commerce\Event;

use Drupal\commerce\EventBase;
use Drupal\commerce_payment\Entity\PaymentInterface;
use zaporylie\Vipps\Model\Checkout\v3\CreateCheckoutSessionRequest;

/**
 * The checkout initiation event.
 */
class InitiateCheckoutEvent extends EventBase {

  /**
   * The event constructor.
   *
   * @param \zaporylie\Vipps\Model\Checkout\v3\CreateCheckoutSessionRequest $request
   *   The checkout session initiation request.
   * @param \Drupal\commerce_payment\Entity\PaymentInterface $payment
   *   The Drupal payment entity.
   */
  public function __construct(protected CreateCheckoutSessionRequest $request, protected PaymentInterface $payment) {}

  /**
   * Gets payment value.
   *
   * @return \Drupal\commerce_payment\Entity\PaymentInterface
   *   The Drupal payment.
   */
  public function getPayment(): PaymentInterface {
    return $this->payment;
  }

  /**
   * Gets request value.
   *
   * @return \zaporylie\Vipps\Model\Checkout\v3\CreateCheckoutSessionRequest
   *   The request.
   */
  public function getRequest(): CreateCheckoutSessionRequest {
    return $this->request;
  }

}
